global Masterlist, AnimSegment, AnimCel, SoundCast, AnimName, AnimOffset, RecordingChan, ImpMood, Hungry, Thirsty, HappySad, HotCold, PlayList, ImpObject, ObjectList

on InitRecord
  set Masterlist to [:]
  set AnimSegment to []
  set AnimCel to []
  set SoundCast to 0
  set AnimName to EMPTY
  set RecordingChan to [2, 3, 4, 5, 6]
end

on RecordAnim alist, offsetflag
  if not voidp(alist) then
    if listp(alist) then
      set RecordingChan to alist
    else
      set RecordingChan to [alist]
    end if
  end if
  if the frameLabel <> 0 then
    CloseAnim()
    if the frameLabel = "theend" then
      set the text of field "AnimList" to string(Masterlist)
      abort()
    end if
    StartAnim()
  end if
  if (the frameSound1 <> 0) and (SoundCast <> the frameSound1) then
    AddSound()
  end if
  AddCel()
end

on CloseAnim
  if count(AnimSegment) then
    addProp(Masterlist, AnimName, AnimSegment)
  end if
  set AnimSegment to []
end

on StartAnim
  set AnimName to the frameLabel
  set SoundCast to 0
  repeat with xxx in RecordingChan
    if the memberNum of sprite xxx <> 0 then
      set AnimOffset to the loc of sprite xxx
      exit repeat
    end if
  end repeat
end

on AddSound
  add(AnimSegment, the frameSound1)
  set SoundCast to the frameSound1
end

on AddCel
  set temp to []
  repeat with xxx in RecordingChan
    set AnimCel to []
    if the memberNum of sprite xxx <> 0 then
      add(AnimCel, the memberNum of sprite xxx)
      if not (AnimName contains "cu ") then
        add(AnimCel, the loc of sprite xxx - AnimOffset)
      else
        add(AnimCel, the loc of sprite xxx)
      end if
      add(temp, AnimCel)
    end if
  end repeat
  add(AnimSegment, temp)
end

on grabsuperlist
  set Masterlist to value(the text of field "AnimList")
end

on initPlayback ImpChannel, tObjectList
  set Hungry to random(100) - 50
  set Thirsty to random(100) - 50
  set HappySad to random(100) - 50
  set HotCold to random(100) - 50
  set ImpMood to "happy"
  set ImpObject to new(script "objects", ImpChannel, "TheImp", 2)
  set ObjectList to [:]
  repeat with xxx in tObjectList
    addProp(ObjectList, getAt(xxx, 1), new(script "objects", getAt(xxx, 1), getAt(xxx, 2), getAt(xxx, 3)))
  end repeat
end

on ProcessClick
  set myclick to the clickOn
  set MyObject to getaProp(ObjectList, myclick)
  if objectp(MyObject) then
    clickObject(MyObject)
  end if
  if myclick = the ObjectChan of ImpObject then
    clickObject(ImpObject)
  end if
end

on animateall
  Animate(ImpObject)
  repeat with yyy in ObjectList
    if objectp(yyy) then
      Animate(yyy)
    end if
  end repeat
end

on BinAND val1, val2
  set bincheck to [1, 2, 4, 8, 16, 32, 64, 128, 256]
  set dloop to getPos(bincheck, val2)
  if dloop > 0 then
    if dloop > 1 then
      set divthingy to getAt(bincheck, dloop)
      set val1 to val1 / divthingy
    end if
    if (val1 / 2) <> (val1 * 0.5) then
      return 1
    else
      return 0
    end if
  end if
end
